// TOPSCCC 9188 COMTEST1
#include<stdio.h>
#include<conio.h>
#include "..\lib\9188A8D.h"

/* ------------------------------------------------------------------- */
void S5DL(int lr_flag,int dd1,int dd2,int dd3,int dd4,int dd5)
{
  unsigned int i,j;
  unsigned int ddx[7];
  ddx[1] = dd1;
  ddx[2] = dd2;
  ddx[3] = dd3;
  ddx[4] = dd4;
  ddx[5] = dd5;
  //Init5DigitLed();		/* 5-digit LED initial */
  for (i=1 ; i<6 ; i++)
  {
       for (j=1 ; j<i+1 ; j++)
       {
        if (lr_flag == 0)
	       Show5DigitLed(6-j,ddx[i-j+1]);  /* show - in 5-digit LED */
	    else
	       Show5DigitLed(j,ddx[j]);  /* show - in 5-digit LED */	    
        DelayMs(20);
       }
  }
  /*Show5DigitLed(1,dd1);		   show - in 5-digit LED */
  /*Show5DigitLed(2,dd2);		   show - in 5-digit LED */
  /*Show5DigitLed(3,dd3);		   show - in 5-digit LED */
  /*Show5DigitLed(4,dd4);		   show - in 5-digit LED */
  /*Show5DigitLed(5,dd5);		   show - in 5-digit LED */  
}
void  main()
{
int i,val,t;
int send_com, read_com,data;
int no_response, turn;
char c;

Init5DigitLed();		/* initial & blank the 5-digit LED  */
InstallCom(4,57600L,8,0,1);	/* COM4, RS-232 */
InstallCom(3,57600L,8,0,1);	/* COM3, RS-232 */

TimerOpen();			/*for DelayMs() */

DelayMs(500);   		/* Delay */
printf("\nCOM3/COM4 RS-232 test");
no_response=0;

  for(turn=0;turn<4;turn++){

    if(turn==0){ 		//set COM3 send data to COM4
       LedOn();
	   send_com=3;
	   read_com=4;
	   data=0x55;
    }
    else if(turn==1)
    {          //set COM3 send data to COM4
	  send_com=3;
	  read_com=4;
      data=0xAA;
    }
    else if(turn==2)
    {          //set COM4 send data to COM3
	  LedOff();
      send_com=4;
	  read_com=3;
	  data=0x55;
    }
    else if(turn==3)
    {          //set COM4 send data to COM3
	  send_com=4;
	  read_com=3;
	  data=0xAA;
	  turn=-1;		//reset the counter
    }
    ToCom(send_com,data);       //send data
    Show5DigitLed(1,data%16);	//show - in 5-digit LED */
    Show5DigitLed(2,data%16);	//show - in 5-digit LED */
    Show5DigitLed(3,17);		//show - in 5-digit LED */

    i=0;
    while(IsCom(read_com)==0) 	//wait for data
    {
	  i++;
	  if (i>30000){
		no_response=1;
		break;
	  }
    }

    //read data if there is any
    if(!no_response){
	  val=ReadCom(read_com);
	  printf("\nCOM%i send %x --> COM%i receive %x",send_com,data,read_com,val);
      Show5DigitLed(4,val%16);		//show - in 5-digit LED */
      Show5DigitLed(5,val%16);		//show - in 5-digit LED */
    }else{
	  printf("\nCOM%i send %x --> COM%i no response",send_com,data,read_com);
	  no_response=0;
    }

    if (kbhit())		/* PC's key hit from COM4 */
    {
       c=getch();		/* press 'q' to exit 	  */
       if ((c=='q') || (c=='Q'))
	  {
	    RestoreCom(4);
	    RestoreCom(3);
	    TimerClose();
        S5DL(0,9,1,8,8,14);
	    return;
	  }
    }
    DelayMs(500);
  }
}
