// TOPSCCC 9188 DEMO3
#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include "..\lib\9188A8D.h"

/* ------------------------------------------------------------------- */
int data;

void S5DL(int lr_flag,int dd1,int dd2,int dd3,int dd4,int dd5)
{
  unsigned int i,j;
  unsigned int ddx[7];
  ddx[1] = dd1;
  ddx[2] = dd2;
  ddx[3] = dd3;
  ddx[4] = dd4;
  ddx[5] = dd5;
  
  for (i=1 ; i<6 ; i++)
  {
       Show5DigitLed(1,16);		   /*show - in 5-digit LED */
       Show5DigitLed(2,16);		   /*show - in 5-digit LED */
       Show5DigitLed(3,16);		   /*show - in 5-digit LED */
       Show5DigitLed(4,16);		   /*show - in 5-digit LED */
       Show5DigitLed(5,16);		   /*show - in 5-digit LED */  
       for (j=1 ; j<i+1 ; j++)
       {
        if (lr_flag == 0)
	       Show5DigitLed(6-j,ddx[i-j+1]);  /* show - in 5-digit LED */
	    else
	       Show5DigitLed(j,ddx[j]);  /* show - in 5-digit LED */      
       }
       DelayTimeMs(100);
 }
}
void TestNVRAM(void)
{
  unsigned char NVRAM[31];
  unsigned int j;
  /* read current NVRAM 0-31 */
  for(j=0;j<31;j++){ NVRAM[j]=ReadNVRAM(j); }
  printf("\nCurrent Values are:\n");
  for(j=0;j<31;j++) printf("%3d ",NVRAM[j]);
  for(j=0;j<31;j++) NVRAM[j]++;  		/* increment by 1 */
  printf("\nAll the values are added by 1");
  for (j=0;j<31; j++) WriteNVRAM(j,NVRAM[j]);  /* write to NVRAM for test */
  printf("\nAfter write Values are:\n");
  for(j=0;j<31;j++) printf("%3d ",ReadNVRAM(j));

}
/**********************************************************/
void ExeCommand(void){

  int idx,regidx,quit;
  char c,cmd[20];
  unsigned int j;
  quit=0;
  cmd[0]=0;
  idx=0;
  regidx=0;
  printf("\n Enter 's' for displaying all the NVRAM values");
  printf("\n Enter 'r[index]' for setting the index of NVRAM");
  printf("\n Enter a number for write a value");
  printf("\n Enter 'q' to quite");
  printf("\n>>");
  while(!quit){
    S5DL(0,14,17,17,17,17);           
    if(kbhit()){
       S5DL(1,9,1,8,8,14);
       switch(c=getch()){
	   case 'q': case 'Q': quit=1;
	   case '\r':
	      putch('\r');
	      putch('\n');
	      cmd[idx]=0;
	      switch(cmd[0]){
	       case 's': case 'S': /* show all */
		    for(j=0;j<31;j++) printf("%3d ",ReadNVRAM(j));
		    break;
	       case 'r': case 'R': /* set register idx */
		    regidx=atoi(cmd+1);
		    printf("\nset idx to %d",regidx);
		    break;
	       default:
		    if(cmd[0]>='0' && cmd[0]<='9'){
		       /* set value to current register */
		       data=atoi(cmd);
		       WriteNVRAM(regidx,data);
		       printf("\nwrite %d to index %d",data,regidx);
		    }
	      }
	      idx=0;
	      printf("\n>>");
	      break;
	 case '\b':
	      if(idx){
		     cmd[--idx]=0;
		     putchar(c);
	      }
	      break;
	 default:
	      cmd[idx++]=c;
	      putchar(c);
	      break;
       }
    }
  }

}
/***********************************************************/
void  main()
{
  Init5DigitLed();		  /* 5-digit LED initial  */
  //Show5DigitLed(3,17);  /* show - in 5-digit LED */

  TestNVRAM();			  /* perform some basic test */
  ExeCommand();			  /* execute commands from users' input */
  S5DL(0,9,1,8,8,14);
}
