// TOPSCCC 9188 DEMO8
/*
   Count the time by using StopWatch and use it to control LED on/off

*/
#include<stdio.h>
#include"..\lib\9188A8D.h"


void main(void)
{ int Led=0;
  unsigned long count;
  int quit=0;

  printf("\nPress 'q' to quit");
  printf("\nPress 's' to use StopWatchStop()");
  printf("\nPress 'p' to use StopWatchPause()");
  printf("\nPress 'c' to use StopWatchContinue()");
  printf("\nPress 'r' to use StopWatchReset()\n");

  TimerOpen();
  LedOff();
  StopWatchStart(0);		//use channel 0

  while(!quit){

     StopWatchReadValue(0,&count);	//Read the current value

     // 2sec delay
     if(count>=2000){
	StopWatchStart(0);
	if(Led){
	   Led=0;
	   LedOff();
	}
	else {
	   Led=1;
	   LedOn();
	}
     }

     if(kbhit4()){
	switch(getch4()){
	  case 'q':
	       quit=1;
	       break;
	  case 's':
		StopWatchStop(0);
		break;
	  case 'p':
		StopWatchPause(0);
		break;
	  case 'c':
		StopWatchContinue(0);
		break;
	  case 'r':
		StopWatchReset(0);
		break;
	  default:
		break;

	  }
     }
  }
  TimerClose();
  LedOn();
}

