// TOPSCCC 9188 DEMO2
#include<stdio.h>
#include<conio.h>
#include "..\lib\9188A8D.h"
void S5DL(int lr_flag,int dd1,int dd2,int dd3,int dd4,int dd5)
{
  unsigned int i,j;
  unsigned int ddx[7];
  ddx[1] = dd1;
  ddx[2] = dd2;
  ddx[3] = dd3;
  ddx[4] = dd4;
  ddx[5] = dd5;
  //Init5DigitLed();		/* 5-digit LED initial */
  for (i=1 ; i<6 ; i++)
  {
       for (j=1 ; j<i+1 ; j++)
       {
        if (lr_flag == 0)
	       Show5DigitLed(6-j,ddx[i-j+1]);  /* show - in 5-digit LED */
	    else
	       Show5DigitLed(j,ddx[j]);  /* show - in 5-digit LED */	    
        DelayMs(20);
       }
  }
  /*Show5DigitLed(1,dd1);		   show - in 5-digit LED */
  /*Show5DigitLed(2,dd2);		   show - in 5-digit LED */
  /*Show5DigitLed(3,dd3);		   show - in 5-digit LED */
  /*Show5DigitLed(4,dd4);		   show - in 5-digit LED */
  /*Show5DigitLed(5,dd5);		   show - in 5-digit LED */  
}
//global v
int q=0,w=0,e=0;

/* ------------------------------------------------------------------- */
void PerformTest(void){
  int i1,i2,i3,j,value;
  char c;

  i1=i2=i3=0; j=0;
  LedOn();	/* red-LED on      */
  printf("\n*********************************"
	 "\n'2': to Get Voltage from EX9017"
	 "\n'3': to Get Current from EX9017"
	 "\n'4': to Get Current from EX9017"	 
	 "\n'q': quit"
	 "\nPlease keyin to select...");
  while(1)
  {
    if (IsCom(4)==QueueIsNotEmpty) /*is COM4 receive any data ?		       */
    {			/* Yes, receive some data		    */
       value=ReadCom(4);	/* read one character from COM4 		    */
       ToCom(4,value);		/* send this character back to COM4		    */
				/* --> you will see this character in PC's monitor  */
       printf("\nCOM4 get %x times", value);
       ClearCom(4);
       i1++; i1=i1&0x07; Show5DigitLed(5,i1);
       j++; j=j&0x01; if (j==0) LedOn(); else LedOff();
    }

    if (IsCom(2)==QueueIsNotEmpty) /* is COM2 receive any data ?		       */
    {			/* Yes, receive some data		    */
       value=ReadCom(2);	/* read one character from COM2 	    */
       printf("\nCOM2 get %x times", value);

	//Set485DirToTransmit(2);	/* change 485 direction to Transmit	    */
	ToCom(2,value);		/* send this character back to COM2	    */
				/* --> you will see this character in PC's monitor  */
	//WaitTransmitOver(2);	/* wait this character transmit over	    */
	//Set485DirToReceive(2);	/* change 485 direction to Receive	    */
	

       i2++; i2=i2&0x07; Show5DigitLed(1,i2);
       j++; j=j&0x01; if (j==0) LedOn(); else LedOff();

    }

    if (IsCom(3)==QueueIsNotEmpty) /* is COM3 receive any data ?		       */
    {				/* Yes, receive some data			   */
       value=ReadCom(3);	/* read one character from COM3 		   */
       ToCom(3,value);		/* send this character back to COM3		   */
				/* --> you will see this character in PC's monitor */
       printf("\nCOM3 get %x times", value);
       ClearCom(3);       
       i3++; i3=i3&0x07; Show5DigitLed(3,i3);
       j++; j=j&0x01; if (j==0) LedOn(); else LedOff();
    }

    if (kbhit())		/* is user press PC's keyboard from COM4       */
    {
       c=getch();		/* if this key is Q or Q --> exit this program */
       if ((c=='q') || (c=='Q'))
       {
	      RestoreCom(4);
	      RestoreCom(2);
	      RestoreCom(3);
          S5DL(0,9,1,8,8,14);
	      return;
       }

       if (c=='4'){
	      ToCom(4,q);	      
	      q++;
       }
       if (c=='2'){
	      //Set485DirToTransmit(2);
	      ToCom(2,e);
	      //WaitTransmitOver(2);
	      //Set485DirToReceive(2);
	      e++;
       }
       if (c=='3'){
	      ToCom(3,w);
	      w++;
       }

    }
  }

}
/************************************************************/
void  main()
{

InstallCom(4,57600L,8,0,1);	/* COM4, RS-232, full-duplex mode, INT	     */
				/*	 Note : JP1 must select RS-232	     */
InstallCom(2,57600L,8,0,1);	/* COM2, RS-485, half-duplex mode, INT	     */
				/*	 --> need to control 485 direction   */
				/*	 --> initial 485 direction = Receive */
InstallCom(3,57600L,8,0,1);	/* COM3, RS-232, full-duplex mode, INT	     */
/* COM1, RS-232, connect to PC's COM port for download */

Init5DigitLed();		/* initial & blank the 5-digit LED	      */
Show5DigitLed(2,17);
Show5DigitLed(4,17);
PerformTest();			/* RS232 and RS485 test */

}
